#include "packagedb.h"

PackageDB::PackageDB()
{
    configPath = QDir::homePath() + "/.config/mib-report/";
    if (!configPath.exists())
    {
        QDir().mkpath(configPath.path());
    }

    statusOK = false;
    statusString = "DB not initialized";
}

/* ============== public functions ============== */

int PackageDB::updateLists()
{
    QTextStream out(stderr);
    int errorCode;

    out << "Downloading MIB 2011.0 lists" << endl;
    out.flush();
    errorCode = system("curl -# -o $HOME/.config/mib-report/info.xml.lzma http://mib.pianetalinux.org/2011.0/32/basic/media_info/info.xml.lzma");
    if (errorCode)
        return errorCode;
    system("lzcat $HOME/.config/mib-report/info.xml.lzma | sed s/\"'\"/\\\\n/g | grep \"src.rpm\" | grep -v \" \" | sort | uniq > $HOME/.config/mib-report/2011.0.txt");
    system("rm -f $HOME/.config/mib-report/info.xml.lzma");

    errorCode = system("curl -# -o $HOME/.config/mib-report/info.xml.lzma http://mib.pianetalinux.org/2011.0/32/experts/media_info/info.xml.lzma");
    if (errorCode)
        return errorCode;
    system("lzcat $HOME/.config/mib-report/info.xml.lzma | sed s/\"'\"/\\\\n/g | grep \"src.rpm\" | grep -v \" \" | sort | uniq >> $HOME/.config/mib-report/2011.0.txt");
    system("rm -f $HOME/.config/mib-report/info.xml.lzma");

    out << "Downloading MIB 2011.0 SRPM lists" << endl;
    out.flush();
    system("lynx --dump http://mib.pianetalinux.org/2011.0/srpms/ | egrep -o \"http:.*\" | grep src > $HOME/.config/mib-report/2011.0-srpms.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading MIB 2010.2 lists" << endl;
    out.flush();
    errorCode = system("curl -# -o $HOME/.config/mib-report/info.xml.lzma http://mib.pianetalinux.org/2010.2/32/basic/media_info/info.xml.lzma");
    if (errorCode)
        return errorCode;
    system("lzcat $HOME/.config/mib-report/info.xml.lzma | sed s/\"'\"/\\\\n/g | grep \"src.rpm\" | grep -v \" \" | sort | uniq > $HOME/.config/mib-report/2010.2.txt");
    system("rm -f $HOME/.config/mib-report/info.xml.lzma");

    errorCode = system("curl -# -o $HOME/.config/mib-report/info.xml.lzma http://mib.pianetalinux.org/2010.2/32/experts/media_info/info.xml.lzma");
    if (errorCode)
        return errorCode;
    system("lzcat $HOME/.config/mib-report/info.xml.lzma | sed s/\"'\"/\\\\n/g | grep \"src.rpm\" | grep -v \" \" | sort | uniq >> $HOME/.config/mib-report/2010.2.txt");
    system("rm -f $HOME/.config/mib-report/info.xml.lzma");

    errorCode = system("curl -# -o $HOME/.config/mib-report/info.xml.lzma http://mib.pianetalinux.org/2010.2/32/testing/media_info/info.xml.lzma");
    if (errorCode)
        return errorCode;
    system("lzcat $HOME/.config/mib-report/info.xml.lzma | sed s/\"'\"/\\\\n/g | grep \"src.rpm\" | grep -v \" \" | sort | uniq >> $HOME/.config/mib-report/2010.2.txt");
    system("rm -f $HOME/.config/mib-report/info.xml.lzma");

    errorCode = system("curl -# -o $HOME/.config/mib-report/info.xml.lzma http://mib.pianetalinux.org/2010.2/others/kde/4.5.5/32/release/media_info/info.xml.lzma");
    if (errorCode)
        return errorCode;
    system("lzcat $HOME/.config/mib-report/info.xml.lzma | sed s/\"'\"/\\\\n/g | grep \"src.rpm\" | grep -v \" \" | sort | uniq >> $HOME/.config/mib-report/2010.2.txt");
    system("rm -f $HOME/.config/mib-report/info.xml.lzma");

    errorCode = system("curl -# -o $HOME/.config/mib-report/info.xml.lzma http://mib.pianetalinux.org/2010.2/others/kde/4.5.5/32/updates/media_info/info.xml.lzma");
    if (errorCode)
        return errorCode;
    system("lzcat $HOME/.config/mib-report/info.xml.lzma | sed s/\"'\"/\\\\n/g | grep \"src.rpm\" | grep -v \" \" | sort | uniq >> $HOME/.config/mib-report/2010.2.txt");
    system("rm -f $HOME/.config/mib-report/info.xml.lzma");

    errorCode = system("curl -# -o $HOME/.config/mib-report/info.xml.lzma http://mib.pianetalinux.org/2010.2/others/kde/4.5.5/32/testing/media_info/info.xml.lzma");
    if (errorCode)
        return errorCode;
    system("lzcat $HOME/.config/mib-report/info.xml.lzma | sed s/\"'\"/\\\\n/g | grep \"src.rpm\" | grep -v \" \" | sort | uniq >> $HOME/.config/mib-report/2010.2.txt");
    system("rm -f $HOME/.config/mib-report/info.xml.lzma");

    errorCode = system("curl -# -o $HOME/.config/mib-report/info.xml.lzma http://mib.pianetalinux.org/2010.2/others/kde/4.5.5/32/others/media_info/info.xml.lzma");
    if (errorCode)
        return errorCode;
    system("lzcat $HOME/.config/mib-report/info.xml.lzma | sed s/\"'\"/\\\\n/g | grep \"src.rpm\" | grep -v \" \" | sort | uniq >> $HOME/.config/mib-report/2010.2.txt");
    system("rm -f $HOME/.config/mib-report/info.xml.lzma");

    errorCode = system("curl -# -o $HOME/.config/mib-report/info.xml.lzma http://mib.pianetalinux.org/2010.2/others/kde/45X-extras/32/media_info/info.xml.lzma");
    if (errorCode)
        return errorCode;
    system("lzcat $HOME/.config/mib-report/info.xml.lzma | sed s/\"'\"/\\\\n/g | grep \"src.rpm\" | grep -v \" \" | sort | uniq >> $HOME/.config/mib-report/2010.2.txt");
    system("rm -f $HOME/.config/mib-report/info.xml.lzma");

    out << "Downloading MIB 2010.2 SRPM lists" << endl;
    out.flush();
    system("lynx --dump http://mib.pianetalinux.org/2010.2/srpms/ | egrep -o \"http:.*\" | grep src > $HOME/.config/mib-report/2010.2-srpms.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();
    system("lynx --dump http://mib.pianetalinux.org/2010.2/others/kde/45X-extras/srpms/ | egrep -o \"http:.*\" | grep src >> $HOME/.config/mib-report/2010.2-srpms.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();
    system("lynx --dump http://mib.pianetalinux.org/2010.2/32/testing/srpms/ | egrep -o \"http:.*\" | grep src >> $HOME/.config/mib-report/2010.2-srpms.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading MIB 2010.0 lists" << endl;
    out.flush();
    system("lynx --dump http://mib.pianetalinux.org/2010.0/srpms/ | egrep -o \"http:.*\" | grep src > $HOME/.config/mib-report/2010.0.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading MIB 2009.1 lists" << endl;
    out.flush();
    system("lynx --dump http://mib.pianetalinux.org/2009.1/SRPMS/ | egrep -o \"http:.*\" | grep src > $HOME/.config/mib-report/2009.1.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading MIB 2011.0 SRPM lists" << endl;
    out.flush();
    system("lynx --dump http://mib.pianetalinux.org/2011.0/srpms/ | egrep -o \"http:.*\" | grep src > $HOME/.config/mib-report/2011.0-srpms.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading Mandriva Cooker Main lists" << endl;
    out.flush();
    system("lynx --dump http://distrib-coffee.ipsl.jussieu.fr/pub/linux/MandrivaLinux/devel/cooker/SRPMS/main/release/ | egrep -o \"http:.*\" | grep src > $HOME/.config/mib-report/cooker.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading Mandriva Cooker Contrib lists" << endl;
    out.flush();
    system("lynx --dump http://distrib-coffee.ipsl.jussieu.fr/pub/linux/MandrivaLinux/devel/cooker/SRPMS/contrib/release/ | egrep -o \"http:.*\" | grep src >> $HOME/.config/mib-report/cooker.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading Mandriva Cooker Non-Free lists" << endl;
    out.flush();
    system("lynx --dump http://distrib-coffee.ipsl.jussieu.fr/pub/linux/MandrivaLinux/devel/cooker/SRPMS/non-free/release/ | egrep -o \"http:.*\" | grep src >> $HOME/.config/mib-report/cooker.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading Mandriva Restricted lists" << endl;
    out.flush();
    system("lynx --dump http://mib.pianetalinux.org/2011.0/srpms_restricted/ | egrep -o \"http:.*\" | grep src > $HOME/.config/mib-report/restricted.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading EduMandriva 2010.2 Free lists" << endl;
    out.flush();
    system("lynx --dump http://mirror.yandex.ru/mirrors/EduMandriva/educontrib/2010.1/SRCRPM/free/ | egrep -o \"http:.*\" | grep src > $HOME/.config/mib-report/edu.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading EduMandriva 2010.2 Non-Free lists" << endl;
    out.flush();
    system("lynx --dump http://mirror.yandex.ru/mirrors/EduMandriva/educontrib/2010.1/SRCRPM/non-free/ | egrep -o \"http:.*\" | grep src >> $HOME/.config/mib-report/edu.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading EduMandriva 2011.0 Free lists" << endl;
    out.flush();
    system("lynx --dump http://mirror.yandex.ru/mirrors/EduMandriva/educontrib/2011.0/SRCRPM/free/release/ | egrep -o \"http:.*\" | grep src >> $HOME/.config/mib-report/edu.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading EduMandriva 2011.0 Non-Free lists" << endl;
    out.flush();
    system("lynx --dump http://mirror.yandex.ru/mirrors/EduMandriva/educontrib/2011.0/SRCRPM/non-free/release/ | egrep -o \"http:.*\" | grep src >> $HOME/.config/mib-report/edu.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading MRB 2010.2 lists" << endl;
    out.flush();
    system("lynx --dump http://mrb.mandrivausers.ro/MRB/2010.2/i686/MRB-srpms/ | egrep -o \"http:.*\" | grep src > $HOME/.config/mib-report/mrb.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading MRB 2011.0 lists" << endl;
    out.flush();
    system("lynx --dump http://mrb.mandrivausers.ro/MRB/2011.0/i686/MRB-srpms/ | egrep -o \"http:.*\" | grep src >> $HOME/.config/mib-report/mrb.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading Mageia Cauldron Core lists" << endl;
    out.flush();
    system("lynx --dump http://distrib-coffee.ipsl.jussieu.fr/pub/linux/Mageia/distrib/cauldron/SRPMS/core/release/ | egrep -o \"http:.*\" | grep src > $HOME/.config/mib-report/cauldron.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading Mageia Cauldron Tainted lists" << endl;
    out.flush();
    system("lynx --dump http://distrib-coffee.ipsl.jussieu.fr/pub/linux/Mageia/distrib/cauldron/SRPMS/tainted/release/ | egrep -o \"http:.*\" | grep src >> $HOME/.config/mib-report/cauldron.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading Mageia Cauldron Non-Free lists" << endl;
    out.flush();
    system("lynx --dump http://distrib-coffee.ipsl.jussieu.fr/pub/linux/Mageia/distrib/cauldron/SRPMS/nonfree/release/ | egrep -o \"http:.*\" | grep src >> $HOME/.config/mib-report/cauldron.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading PCLinuxOS Main lists" << endl;
    out.flush();
    system("lynx --dump http://distrib-coffee.ipsl.jussieu.fr/pub/linux/pclinuxos/apt/pclinuxos/2010/SRPMS.main/ | egrep -o \"http:.*\" | grep src > $HOME/.config/mib-report/pclinuxos.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading PCLinuxOS Updates lists" << endl;
    out.flush();
    system("lynx --dump http://distrib-coffee.ipsl.jussieu.fr/pub/linux/pclinuxos/apt/pclinuxos/2010/SRPMS.updates/ | egrep -o \"http:.*\" | grep src > $HOME/.config/mib-report/pclinuxos.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading PCLinuxOS Games lists" << endl;
    out.flush();
    system("lynx --dump http://distrib-coffee.ipsl.jussieu.fr/pub/linux/pclinuxos/apt/pclinuxos/2010/SRPMS.games/ | egrep -o \"http:.*\" | grep src >> $HOME/.config/mib-report/pclinuxos.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading Fedora Rawhide lists" << endl;
    out.flush();
    errorCode = system("curl -o $HOME/.config/mib-report/fedora.gz -# `lynx --dump http://mirror.yandex.ru/fedora/linux/development/rawhide/source/SRPMS/repodata/ | egrep -o \"http:.*\" | grep primary.xml.gz`");
    if (errorCode)
        return errorCode;
    errorCode = system("zcat $HOME/.config/mib-report/fedora.gz | grep src.rpm | sed s,\\\"/\\>,,g | sed s,\\<location\\ href=\\\",http://mirror.yandex.ru/fedora/linux/development/rawhide/source/SRPMS/,g > $HOME/.config/mib-report/fedora.txt");
    if (errorCode)
        return errorCode;
    system("rm -f $HOME/.config/mib-report/fedora.gz");
    out.flush();

    out << "Downloading Fedora Rawhide RPM Fusion Free lists" << endl;
    out.flush();
    system("lynx --dump http://download1.rpmfusion.org/free/fedora/development/source/SRPMS/ | egrep -o \"http:.*\" | grep src >> $HOME/.config/mib-report/fedora.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading Fedora Rawhide RPM Fusion Non-Free lists" << endl;
    out.flush();
    system("lynx --dump http://download1.rpmfusion.org/nonfree/fedora/development/source/SRPMS/ | egrep -o \"http:.*\" | grep src >> $HOME/.config/mib-report/fedora.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading Alt Linux Sisyphus lists" << endl;
    out.flush();
    system("lynx --dump http://mirror.yandex.ru/altlinux/Sisyphus/files/SRPMS/ | egrep -o \"http:.*\" | grep src > $HOME/.config/mib-report/sisyphus.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading OpenSUSE OSS lists" << endl;
    out.flush();
    system("lynx --dump http://download.opensuse.org/source/factory/repo/oss/suse/src/ | egrep -o \"http:.*\" | grep src > $HOME/.config/mib-report/opensuse.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading OpenSUSE Non-OSS lists" << endl;
    out.flush();
    system("lynx --dump http://download.opensuse.org/source/factory/repo/non-oss/suse/src/ | egrep -o \"http:.*\" | grep src >> $HOME/.config/mib-report/opensuse.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading OpenSUSE Emulators lists" << endl;
    out.flush();
    system("lynx --dump http://ftp5.gwdg.de/pub/opensuse/repositories/Emulators/openSUSE_Factory/src/ | egrep -o \"http:.*\" | grep src >> $HOME/.config/mib-report/opensuse.txt");
    out << "######################################################################## 100,0%" << endl;
    out.flush();

    out << "Downloading Gentoo lists" << endl;
    out.flush();
    errorCode = system("curl -# -o $HOME/.config/mib-report/portage-latest.tar.bz2 http://mirror.yandex.ru/gentoo-distfiles/snapshots/portage-latest.tar.bz2");
    if (errorCode)
        return errorCode;
    out << "Preparing downloaded Gentoo lists" << endl;
    out.flush();
    errorCode = system("tar -tjf $HOME/.config/mib-report/portage-latest.tar.bz2 | grep ebuild | grep -v \"9999\" | sed s/-r.*ebuild/.ebuild/g | sed s/.ebuild/-1.ebuild/g > $HOME/.config/mib-report/gentoo.txt");
    if (errorCode)
        return errorCode;
    system("rm -f $HOME/.config/mib-report/portage-latest.tar.bz2");

    out << "Downloading Debian lists" << endl;
    out.flush();
    errorCode = system("curl -# -o $HOME/.config/mib-report/ls-lR.gz http://mirror.yandex.ru/debian/ls-lR.gz");
    if (errorCode)
        return errorCode;
    out << "Preparing downloaded Debian lists" << endl;
    out.flush();
    errorCode = system("zcat $HOME/.config/mib-report/ls-lR.gz | grep \"dsc\" | sed s/_/-/g | awk '{print $9;}' | sed s/+.*dsc/-1.dsc/g > $HOME/.config/mib-report/debian.txt");
    if (errorCode)
        return errorCode;
    system("rm -f $HOME/.config/mib-report/ls-lR.gz");

    out << "Downloading Ubuntu lists" << endl;
    out.flush();
    errorCode = system("curl -# -o $HOME/.config/mib-report/ls-lR.gz http://mirror.yandex.ru/ubuntu/ls-lR.gz");
    if (errorCode)
        return errorCode;
    out << "Preparing downloaded Ubuntu lists" << endl;
    out.flush();
    errorCode = system("zcat $HOME/.config/mib-report/ls-lR.gz | grep \"dsc\" | sed s/_/-/g | awk '{print $9;}' | sed s/+.*dsc/-1.dsc/g > $HOME/.config/mib-report/ubuntu.txt");
    if (errorCode)
        return errorCode;
    system("rm -f $HOME/.config/mib-report/ls-lR.gz");

    out << "Done" << endl;
    return 0;
}

void PackageDB::initDB()
{
    mib2009_1List.clear();
    mib2010_0List.clear();
    mib2010_2List.clear();
    mib2011_0List.clear();
    cookerList.clear();
    restrictedList.clear();
    eduList.clear();
    mrbList.clear();
    mageiaList.clear();
    fedoraList.clear();
    sisyphusList.clear();
    gentooList.clear();
    debianList.clear();
    ubuntuList.clear();
    mibPackagesList.clear();
    newPackagesList.clear();

    statusOK = true;
    statusString = "OK";

    readBlacklist();
    readUrls();
    readPackages("2009.1.txt", mib2009_1List, "MIB 2009.1");
    readPackages("2010.0.txt", mib2010_0List, "MIB 2010.0");
    readPackages("2010.2.txt", mib2010_2List, "MIB 2010.2");
    readPackages("2011.0.txt", mib2011_0List, "MIB 2011.0");
    readPackages("cooker.txt", cookerList, "Cooker");
    readPackages("restricted.txt", restrictedList, "Restricted");
    readPackages("edu.txt", eduList, "EduMandriva");
    readPackages("mrb.txt", mrbList, "MRB");
    readPackages("cauldron.txt", mageiaList, "Mageia");
    readPackages("fedora.txt", fedoraList, "Fedora");
    readPackages("pclinuxos.txt", pclinuxosList, "PCLinuxOS");
    readPackages("sisyphus.txt", sisyphusList, "Sisyphus");
    readPackages("opensuse.txt", opensuseList, "openSUSE");
    readPackages("gentoo.txt", gentooList, "Gentoo");
    readPackages("debian.txt", debianList, "Debian");
    readPackages("ubuntu.txt", ubuntuList, "Ubuntu");
    updateListSourceUrls("2010.2-srpms.txt", mib2010_2List);
    updateListSourceUrls("2011.0-srpms.txt", mib2011_0List);

    fullPackagesList << mib2009_1List << mib2010_0List << mib2010_2List << mib2011_0List << restrictedList << cookerList << eduList << mrbList << mageiaList << pclinuxosList << fedoraList << sisyphusList << opensuseList << gentooList << debianList << ubuntuList;

    mibPackagesList << mib2009_1List << mib2010_0List << mib2010_2List << mib2011_0List;
    removeOlds(mibPackagesList);

    newPackagesList << fullPackagesList;
    removeOlds(newPackagesList);
}

void PackageDB::generateHTMLTableMIB(int mode)
{
    QTextStream out(stdout);
    QTextStream outerr(stderr);
    outerr << "Table generation started" << endl;
    out << "<html><head>" << endl;
    out << "<title>MIB Packages Table</title>" << endl;
    out << "<style type=\"text/css\">" << endl;
    out << "th {background-color:#CCCCCC; border: 1px solid black; padding-right: 10px; padding-left: 10px; font-weight:bold;}" << endl;
    out << "th.bottom {border-top: 2px solid black; text-align:left; padding-right: 2px; padding-left: 2px;}" << endl;
    out << "td {border: 1px solid black; padding-right: 2px; padding-left: 2px;}" << endl;
    out << "table {border: 1px solid black; border-collapse:collapse;}" << endl;
    out << "td.old {background-color:#FFFFCC;}" << endl;
    out << "td.new {background-color:#CCFFCC;}" << endl;
    out << "td.none {background-color:#FFCCCC;}" << endl;
    out << "a {color:#000000; text-decoration:none;}" << endl;
    out << "a:hover {text-decoration:underline;}" << endl;
    out << "</style>" << endl;
    out << "</head><body><table>" << endl;
    out << "<tr><th colspan=7>MIB packages report (generated at " << QDate::currentDate().toString(Qt::ISODate) << ")</th></tr>" << endl;
    out << "<tr><th>Name</th><th>MIB exclusive</th><th>2009.1</th><th>2010.0</th><th>2010.2</th><th>2011.0</th><th>Latest version (where)</th></tr>";

    int mibExclusiveCount = 0;
    int newAvailableCount = 0;
    int in2009_1 = 0;
    int in2010_0 = 0;
    int in2010_2 = 0;
    int in2011_0 = 0;
    for (int j = 0; j < mibPackagesList.count(); j++)
    {
        QString latestVersion = getPackageVersion(mibPackagesList.at(j).name, newPackagesList);
        QString mib2009_1Version = getPackageVersion(mibPackagesList.at(j).name, mib2009_1List);
        QString mib2010_0Version = getPackageVersion(mibPackagesList.at(j).name, mib2010_0List);
        QString mib2010_2Version = getPackageVersion(mibPackagesList.at(j).name, mib2010_2List);
        QString mib2011_0Version = getPackageVersion(mibPackagesList.at(j).name, mib2011_0List);
        bool mibExclusive = false;
        bool show = false;
        QString source;
        QString sourceUrl;
        QString homepage;
        if (getPackageVersion(mibPackagesList.at(j).name, cookerList) == "none")
        {
            mibExclusive = true;
            mibExclusiveCount++;
        }

        if (mode == REPORT_ALL)
        {
            show = true;
        }
        else if ((mode == REPORT_EXCLUSIVES) && mibExclusive)
        {
            show = true;
        }
        else if ((mode == REPORT_UPDATES) && !getPackageSource(mibPackagesList.at(j).name, newPackagesList).contains("MIB"))
        {
            show = true;
        }

        if (show)
        {
            if (mib2009_1Version != "none")
                in2009_1++;
            if (mib2010_0Version != "none")
                in2010_0++;
            if (mib2010_2Version != "none")
                in2010_2++;
            if (mib2011_0Version != "none")
                in2011_0++;

            out << "<tr>" << endl;;
            out << "<td>";
            homepage = getPackageHomepage(mibPackagesList.at(j).name);
            if (!homepage.isEmpty())
                out << "<a href=\"" << homepage << "\">";
            out << mibPackagesList.at(j).name;
            if (!homepage.isEmpty())
                out << "</a>";
            out << "</td>" << endl;

            out << "<td>";
            if (mibExclusive)
                out << "Yes";
            else
                out << "No";
            out << "</td>" << endl;

            if ((mib2009_1Version == "none") && mibExclusive)
                out << "<td class=\"none\">";
            else if (mib2009_1Version == latestVersion)
                out << "<td class=\"new\">";
            else
                out << "<td class=\"old\">";
            sourceUrl = getPackageSourceUrl(mibPackagesList.at(j).name, mib2009_1List);
            if (!sourceUrl.isEmpty())
                out << "<a href=\"" << sourceUrl << "\">";
            out << mib2009_1Version;
            if (!sourceUrl.isEmpty())
                out << "</a>";
            out << "</td>" << endl;

            if ((mib2010_0Version == "none") && mibExclusive)
                out << "<td class=\"none\">";
            else if (mib2010_0Version == latestVersion)
                out << "<td class=\"new\">";
            else
                out << "<td class=\"old\">";
            sourceUrl = getPackageSourceUrl(mibPackagesList.at(j).name, mib2010_0List);
            if (!sourceUrl.isEmpty())
                out << "<a href=\"" << sourceUrl << "\">";
            out << mib2010_0Version;
            if (!sourceUrl.isEmpty())
                out << "</a>";
            out << "</td>" << endl;

            if ((mib2010_2Version == "none") && mibExclusive)
                out << "<td class=\"none\">";
            else if (mib2010_2Version == latestVersion)
                out << "<td class=\"new\">";
            else
                out << "<td class=\"old\">";
            sourceUrl = getPackageSourceUrl(mibPackagesList.at(j).name, mib2010_2List);
            if (!sourceUrl.isEmpty())
                out << "<a href=\"" << sourceUrl << "\">";
            out << mib2010_2Version;
            if (!sourceUrl.isEmpty())
                out << "</a>";
            else if (mibExclusive && (mib2010_2Version != "none"))
                out << " (!!!)";
            out << "</td>" << endl;

            if ((mib2011_0Version == "none") && mibExclusive)
                out << "<td class=\"none\">";
            else if (mib2011_0Version == latestVersion)
                out << "<td class=\"new\">";
            else
                out << "<td class=\"old\">";
            sourceUrl = getPackageSourceUrl(mibPackagesList.at(j).name, mib2011_0List);
            if (!sourceUrl.isEmpty())
                out << "<a href=\"" << sourceUrl << "\">";
            out << mib2011_0Version;
            if (!sourceUrl.isEmpty())
                out << "</a>";
            else if (mibExclusive && (mib2011_0Version != "none"))
                out << " (!!!)";
            out << "</td>" << endl;

            out << "<td>";
            sourceUrl = getPackageSourceUrl(mibPackagesList.at(j).name, newPackagesList);
            if (!sourceUrl.isEmpty())
                out << "<a href=\"" << sourceUrl << "\">";
            out << latestVersion;

            source = getPackageSource(mibPackagesList.at(j).name, newPackagesList);
            if (!source.contains("MIB"))
                newAvailableCount++;
            out << " (" << source << ")";
            if (!sourceUrl.isEmpty())
                out << "</a>";
            out << "</td>" << endl;

            out << "</tr>" << endl;
        }
    }

    out << "<tr><th class=\"bottom\"><b>Total: " << mibPackagesList.count() << "</b></th>";
    out << "<th class=\"bottom\">" << mibExclusiveCount << "</th>";
    out << "<th class=\"bottom\">" << in2009_1 << "</th>";
    out << "<th class=\"bottom\">" << in2010_0 << "</th>";
    out << "<th class=\"bottom\">" << in2010_2 << "</th>";
    out << "<th class=\"bottom\">" << in2011_0 << "</th>";
    out << "<th class=\"bottom\">Not in MIB: " << newAvailableCount << "</th></tr>";
    out << "</table></body></html>" << endl;

    outerr << "Table generation complete" << endl;
}

void PackageDB::generateHTMLTableMGAvsMDV(int mode)
{
    QTextStream out(stdout);
    QTextStream outerr(stderr);
    outerr << "Table generation started" << endl;
    out << "<html><head>" << endl;
    out << "<title>MGA vs MDV Packages Table</title>" << endl;
    out << "<style type=\"text/css\">" << endl;
    out << "th {background-color:#CCCCCC; border: 1px solid black; padding-right: 10px; padding-left: 10px; font-weight:bold;}" << endl;
    out << "th.bottom {border-top: 2px solid black; text-align:center; padding-right: 2px; padding-left: 2px;}" << endl;
    out << "td {border: 1px solid black; padding-right: 2px; padding-left: 2px;}" << endl;
    out << "table {border: 1px solid black; border-collapse:collapse;}" << endl;
    out << "td.old {background-color:#FFFFCC;}" << endl;
    out << "td.new {background-color:#CCFFCC;}" << endl;
    out << "td.none {background-color:#FFCCCC;}" << endl;
    out << "a {color:#000000; text-decoration:none;}" << endl;
    out << "a:hover {text-decoration:underline;}" << endl;
    out << "</style>" << endl;
    out << "</head><body><p><table>" << endl;
    out << "<tr><th colspan=5>MGA vs MDV packages report (generated at " << QDate::currentDate().toString(Qt::ISODate) << ")</th></tr>" << endl;
    out << "<tr><th>Name</th><th>MGA exclusive</th><th>MGA</th><th>MDV</th><th>Latest version (where)</th></tr>";

    int mgaExclusiveCount = 0;
    int newAvailableCount = 0;
    int mgaOutdated = 0;
    int mdvLess = 0;
    int inMGA = 0;
    int inMDV = 0;
    for (int j = 0; j < mageiaList.count(); j++)
    {
        QString latestVersion = getPackageVersion(mageiaList.at(j).name, newPackagesList);
        QString mgaVersion = getPackageVersion(mageiaList.at(j).name, mageiaList);
        if (mgaVersion != latestVersion)
            mgaOutdated++;
        QString mdvVersion = getPackageVersion(mageiaList.at(j).name, cookerList);
        bool mgaExclusive = false;
        bool show = false;
        QString source;
        QString sourceUrl;
        QString homepage;
        if (getPackageVersion(mageiaList.at(j).name, cookerList) == "none")
        {
            mgaExclusive = true;
            mgaExclusiveCount++;
        }

        bool versionLess = checker.firstVersionLess(mdvVersion, mgaVersion);
        if (!mgaExclusive && versionLess)
            mdvLess++;

        if ((mode == REPORT_ALL) && (mdvVersion != latestVersion) && versionLess)
        {
            show = true;
        }
        else if ((mode == REPORT_EXCLUSIVES) && mgaExclusive)
        {
            show = true;
        }
        else if ((mode == REPORT_UPDATES) && !mgaExclusive && (mdvVersion != latestVersion) && versionLess)
        {
            show = true;
        }

        if (show)
        {
            if (mgaVersion != "none")
                inMGA++;
            if (mdvVersion != "none")
                inMDV++;

            out << "<tr>" << endl;;
            out << "<td>";
            homepage = getPackageHomepage(mageiaList.at(j).name);
            if (!homepage.isEmpty())
                out << "<a href=\"" << homepage << "\">";
            out << mageiaList.at(j).name;
            if (!homepage.isEmpty())
                out << "</a>";
            out << "</td>" << endl;

            out << "<td>";
            if (mgaExclusive)
                out << "Yes";
            else
                out << "No";
            out << "</td>" << endl;

            if (mgaVersion == latestVersion)
                out << "<td class=\"new\">";
            else
                out << "<td class=\"old\">";
            sourceUrl = getPackageSourceUrl(mageiaList.at(j).name, mageiaList);
            if (!sourceUrl.isEmpty())
                out << "<a href=\"" << sourceUrl << "\">";
            out << mgaVersion;
            if (!sourceUrl.isEmpty())
                out << "</a>";
            out << "</td>" << endl;

            if ((mdvVersion == "none") && mgaExclusive)
                out << "<td class=\"none\">";
            else if (mdvVersion == latestVersion)
                out << "<td class=\"new\">";
            else
                out << "<td class=\"old\">";
            sourceUrl = getPackageSourceUrl(mageiaList.at(j).name, cookerList);
            if (!sourceUrl.isEmpty())
                out << "<a href=\"" << sourceUrl << "\">";
            out << mdvVersion;
            if (!sourceUrl.isEmpty())
                out << "</a>";
            out << "</td>" << endl;

            out << "<td>";
            sourceUrl = getPackageSourceUrl(mageiaList.at(j).name, newPackagesList);
            if (!sourceUrl.isEmpty())
                out << "<a href=\"" << sourceUrl << "\">";
            out << latestVersion;

            source = getPackageSource(mageiaList.at(j).name, newPackagesList);
            if (!source.contains("Cooker"))
                newAvailableCount++;
            out << " (" << source << ")";
            if (!sourceUrl.isEmpty())
                out << "</a>";
            out << "</td>" << endl;

            out << "</tr>" << endl;
        }
    }

//  now statistics for Cooker
    int mdvExclusiveCount = 0;
    int mdvOutdated = 0;
    int mgaLess = 0;
    for (int j = 0; j < cookerList.count(); j++)
    {
        bool mdvExclusive = false;
        if (getPackageVersion(cookerList.at(j).name, mageiaList) == "none")
        {
            mdvExclusive = true;
            mdvExclusiveCount++;
        }
        QString latestVersion = getPackageVersion(cookerList.at(j).name, newPackagesList);
        QString mdvVersion = getPackageVersion(cookerList.at(j).name, cookerList);
        QString mgaVersion = getPackageVersion(cookerList.at(j).name, mageiaList);
        if (mdvVersion != latestVersion)
            mdvOutdated++;

        bool versionLess = checker.firstVersionLess(mgaVersion, mdvVersion);
        if (!mdvExclusive && versionLess)
            mgaLess++;
    }

    out << "<tr><th colspan=5 class=\"Bottom\">Statistics</th></tr>" << endl;
    out << "<tr><th>Distrib</th><th>Total packages</th><th>Exclusives</th><th>Outdated VS</th><th>Outdated total</th></tr>";

    out << "<tr><td>Cauldron</td>";
    out << "<td>" << mageiaList.count() << "</td>";
    out << "<td>" << mgaExclusiveCount << "</td>";
    out << "<td>" << mgaLess << "</td>";
    out << "<td>" << mgaOutdated << "</td></tr>";

    out << "<tr><td>Cooker</td>";
    out << "<td>" << cookerList.count() << "</td>";
    out << "<td>" << mdvExclusiveCount << "</td>";
    out << "<td>" << mdvLess << "</td>";
    out << "<td>" << mdvOutdated << "</td></tr>";
    out << "</table></p></body></html>" << endl;
    outerr << "Table generation complete" << endl;
}

void PackageDB::generateHTMLTableMDVvsMGA(int mode)
{
    QTextStream out(stdout);
    QTextStream outerr(stderr);
    outerr << "Table generation started" << endl;
    out << "<html><head>" << endl;
    out << "<title>MDV vs MGA Packages Table</title>" << endl;
    out << "<style type=\"text/css\">" << endl;
    out << "th {background-color:#CCCCCC; border: 1px solid black; padding-right: 10px; padding-left: 10px; font-weight:bold;}" << endl;
    out << "th.bottom {border-top: 2px solid black; text-align:center; padding-right: 2px; padding-left: 2px;}" << endl;
    out << "td {border: 1px solid black; padding-right: 2px; padding-left: 2px;}" << endl;
    out << "table {border: 1px solid black; border-collapse:collapse;}" << endl;
    out << "td.old {background-color:#FFFFCC;}" << endl;
    out << "td.new {background-color:#CCFFCC;}" << endl;
    out << "td.none {background-color:#FFCCCC;}" << endl;
    out << "a {color:#000000; text-decoration:none;}" << endl;
    out << "a:hover {text-decoration:underline;}" << endl;
    out << "</style>" << endl;
    out << "</head><body><p><table>" << endl;
    out << "<tr><th colspan=5>MDV vs MGA packages report (generated at " << QDate::currentDate().toString(Qt::ISODate) << ")</th></tr>" << endl;
    out << "<tr><th>Name</th><th>MDV exclusive</th><th>MDV</th><th>MGA</th><th>Latest version (where)</th></tr>";

    int mdvExclusiveCount = 0;
    int newAvailableCount = 0;
    int mdvOutdated = 0;
    int mgaLess = 0;
    int inMGA = 0;
    int inMDV = 0;
    for (int j = 0; j < cookerList.count(); j++)
    {
        QString latestVersion = getPackageVersion(cookerList.at(j).name, newPackagesList);
        QString mdvVersion = getPackageVersion(cookerList.at(j).name, cookerList);
        if (mdvVersion != latestVersion)
            mdvOutdated++;
        QString mgaVersion = getPackageVersion(cookerList.at(j).name, mageiaList);
        bool mdvExclusive = false;
        bool show = false;
        QString source;
        QString sourceUrl;
        QString homepage;
        if (getPackageVersion(cookerList.at(j).name, mageiaList) == "none")
        {
            mdvExclusive = true;
            mdvExclusiveCount++;
        }

        bool versionLess = checker.firstVersionLess(mgaVersion, mdvVersion);
        if (!mdvExclusive && versionLess)
            mgaLess++;

        if ((mode == REPORT_ALL) && (mgaVersion != latestVersion) && versionLess)
        {
            show = true;
        }
        else if ((mode == REPORT_EXCLUSIVES) && mdvExclusive)
        {
            show = true;
        }
        else if ((mode == REPORT_UPDATES) && !mdvExclusive && (mgaVersion != latestVersion) && versionLess)
        {
            show = true;
        }

        if (show)
        {
            if (mgaVersion != "none")
                inMGA++;
            if (mdvVersion != "none")
                inMDV++;

            out << "<tr>" << endl;;
            out << "<td>";
            homepage = getPackageHomepage(cookerList.at(j).name);
            if (!homepage.isEmpty())
                out << "<a href=\"" << homepage << "\">";
            out << cookerList.at(j).name;
            if (!homepage.isEmpty())
                out << "</a>";
            out << "</td>" << endl;

            out << "<td>";
            if (mdvExclusive)
                out << "Yes";
            else
                out << "No";
            out << "</td>" << endl;

            if (mdvVersion == latestVersion)
                out << "<td class=\"new\">";
            else
                out << "<td class=\"old\">";
            sourceUrl = getPackageSourceUrl(cookerList.at(j).name, cookerList);
            if (!sourceUrl.isEmpty())
                out << "<a href=\"" << sourceUrl << "\">";
            out << mdvVersion;
            if (!sourceUrl.isEmpty())
                out << "</a>";
            out << "</td>" << endl;

            if ((mgaVersion == "none") && mdvExclusive)
                out << "<td class=\"none\">";
            else if (mgaVersion == latestVersion)
                out << "<td class=\"new\">";
            else
                out << "<td class=\"old\">";
            sourceUrl = getPackageSourceUrl(cookerList.at(j).name, mageiaList);
            if (!sourceUrl.isEmpty())
                out << "<a href=\"" << sourceUrl << "\">";
            out << mgaVersion;
            if (!sourceUrl.isEmpty())
                out << "</a>";
            out << "</td>" << endl;

            out << "<td>";
            sourceUrl = getPackageSourceUrl(cookerList.at(j).name, newPackagesList);
            if (!sourceUrl.isEmpty())
                out << "<a href=\"" << sourceUrl << "\">";
            out << latestVersion;

            source = getPackageSource(cookerList.at(j).name, newPackagesList);
            if (!source.contains("Mageia"))
                newAvailableCount++;
            out << " (" << source << ")";
            if (!sourceUrl.isEmpty())
                out << "</a>";
            out << "</td>" << endl;

            out << "</tr>" << endl;
        }
    }

//  now statistics for Mageia Cauldron
    int mgaExclusiveCount = 0;
    int mgaOutdated = 0;
    int mdvLess = 0;
    for (int j = 0; j < mageiaList.count(); j++)
    {
        bool mgaExclusive = false;
        if (getPackageVersion(mageiaList.at(j).name, cookerList) == "none")
        {
            mgaExclusive = true;
            mgaExclusiveCount++;
        }
        QString latestVersion = getPackageVersion(mageiaList.at(j).name, newPackagesList);
        QString mgaVersion = getPackageVersion(mageiaList.at(j).name, mageiaList);
        QString mdvVersion = getPackageVersion(mageiaList.at(j).name, cookerList);
        if (mgaVersion != latestVersion)
            mgaOutdated++;

        bool versionLess = checker.firstVersionLess(mdvVersion, mgaVersion);
        if (!mgaExclusive && versionLess)
            mdvLess++;
    }

    out << "<tr><th colspan=5 class=\"Bottom\">Statistics</th></tr>" << endl;
    out << "<tr><th>Distrib</th><th>Total packages</th><th>Exclusives</th><th>Outdated VS</th><th>Outdated total</th></tr>";

    out << "<tr><td>Cauldron</td>";
    out << "<td>" << mageiaList.count() << "</td>";
    out << "<td>" << mgaExclusiveCount << "</td>";
    out << "<td>" << mgaLess << "</td>";
    out << "<td>" << mgaOutdated << "</td></tr>";

    out << "<tr><td>Cooker</td>";
    out << "<td>" << cookerList.count() << "</td>";
    out << "<td>" << mdvExclusiveCount << "</td>";
    out << "<td>" << mdvLess << "</td>";
    out << "<td>" << mdvOutdated << "</td></tr>";
    out << "</table></p></body></html>" << endl;
    outerr << "Table generation complete" << endl;
}


void PackageDB::search(QString packageName)
{
    QTextStream out(stderr);
    bool found = false;
    for (int j = 0; j < fullPackagesList.count(); j++)
    {
        if (packageName == fullPackagesList.at(j).name)
        {
            found = true;
            out << fullPackagesList.at(j).source << ": ";
            out << fullPackagesList.at(j).version << endl;          
            QString sourceUrl;
            if (fullPackagesList.at(j).sourceUrl.contains("http://"))
                sourceUrl = fullPackagesList.at(j).sourceUrl;
            else if (fullPackagesList.at(j).source == "Gentoo")
                sourceUrl = "http://packages.gentoo.org/package/" + packageName;
            else if (fullPackagesList.at(j).source == "Debian")
                sourceUrl = "http://packages.debian.org/" + packageName;
            else if (fullPackagesList.at(j).source == "Ubuntu")
                sourceUrl = "http://packages.ubuntu.com/" + packageName;
            out << sourceUrl << endl;
        }
    }
    if (!found)
        out << "Package " << packageName << " not found" << endl;
    else
        out << "Homepage URL: " << endl << getPackageHomepage(packageName) << endl;
}

void PackageDB::displayList(QList<Package> &packageList)
{
    QTextStream out(stderr);
    for (int j = 0; j < packageList.count(); j++)
    {
        out << packageList.at(j).name << " " << packageList.at(j).version << " " << packageList.at(j).source << endl;
    }
}

/* ============== private functions ============== */

QString PackageDB::getPackageVersion(QString packageName, QList<Package> &packageList)
{
    QString version = "none";
    for (int j = 0; j < packageList.count(); j++)
    {
        if (packageName == packageList.at(j).name)
        {
            version = packageList.at(j).version;
            break;
        }
    }
    return version;
}

QString PackageDB::getPackageSource(QString packageName, QList<Package> &packageList)
{
    QString source = "";
    for (int j = 0; j < packageList.count(); j++)
    {
        if (packageName == packageList.at(j).name)
        {
            source = packageList.at(j).source;
            break;
        }
    }
    return source;
}

QString PackageDB::getPackageSourceUrl(QString packageName, QList<Package> &packageList)
{
    QString sourceUrl = "";
    for (int j = 0; j < packageList.count(); j++)
    {
        if (packageName == packageList.at(j).name)
        {
            if (packageList.at(j).sourceUrl.contains("http://"))
                sourceUrl = packageList.at(j).sourceUrl;
            else if (packageList.at(j).source == "Gentoo")
                sourceUrl = "http://packages.gentoo.org/package/" + packageName;
            else if (packageList.at(j).source == "Debian")
                sourceUrl = "http://packages.debian.org/" + packageName;
            else if (packageList.at(j).source == "Ubuntu")
                sourceUrl = "http://packages.ubuntu.com/" + packageName;
            break;
        }
    }
    return sourceUrl;
}

QString PackageDB::getUpdatedSourceUrl(QString inFileName, Package inPackage)
{
    QString updatedSourceUrl = "";
    QTextStream out(stderr);
    QFile inFile;
    inFile.setFileName(configPath.absolutePath() + "/" + inFileName);
    if (!inFile.open(QIODevice::ReadOnly | QIODevice::Text))
    {
        out << "Error opening file " << configPath.absolutePath() << "/" << inFileName << "!\n";
        statusOK = false;
        statusString = "Error opening file " + configPath.absolutePath() + "/" + inFileName;
    }
    else
    {
        QTextStream fileIn(&inFile);

        // hack for rebuilt packages
        inPackage.sourceUrl.remove("mib2010.2.src.rpm");
        inPackage.sourceUrl.remove("mib2010.1.src.rpm");
        inPackage.sourceUrl.remove("mib2009.1.src.rpm");
        inPackage.sourceUrl.remove(".src.rpm");

        while (!fileIn.atEnd())
        {
            QString line = fileIn.readLine();
            if (line.contains(inPackage.sourceUrl))
            {
                updatedSourceUrl = line;
                break;
            }
        }
        inFile.close();
    }
    return updatedSourceUrl;
}

void PackageDB::updateListSourceUrls(QString inFileName, QList<Package> &packageList)
{
    for (int j = 0; j < packageList.count(); j++)
    {
        packageList[j].sourceUrl = getUpdatedSourceUrl(inFileName, packageList.at(j));
    }
}

void PackageDB::removeOlds(QList<Package> &packageList)
{
    qSort(packageList);
    int j = 0;
    while (j < packageList.count() - 1)
    {
        if ((packageList.at(j).name == packageList.at(j+1).name) && ((packageList.at(j).version == packageList.at(j+1).version) || checker.firstVersionLess(packageList.at(j).version, packageList.at(j+1).version)))
            packageList.removeAt(j);
        else
            j++;
    }
}

bool PackageDB::readPackages(QString inFileName, QList<Package> &packageList, QString packageSource)
{
    QTextStream out(stderr);
    QFile inFile;
    inFile.setFileName(configPath.absolutePath() + "/" + inFileName);
    if (!inFile.open(QIODevice::ReadOnly | QIODevice::Text))
    {
        out << "Error opening file " << configPath.absolutePath() << "/" << inFileName << "!\n";
        statusOK = false;
        statusString = "Error opening file " + configPath.absolutePath() + "/" + inFileName;
        return false;
    }
    else
    {
        QTextStream fileIn(&inFile);
        while (!fileIn.atEnd())
        {
            Package tempPackage;
            QString line = fileIn.readLine();
            tempPackage.sourceUrl = line;
            line = line.right(line.length() - line.lastIndexOf("/") - 1);
            tempPackage.release = line.right(line.length() - line.lastIndexOf("-") - 1);
            line = line.left(line.lastIndexOf("-"));
            tempPackage.name = line.left(line.lastIndexOf("-")).toLower();
            tempPackage.version = line.right(line.length() - line.lastIndexOf("-") - 1);
            tempPackage.source = packageSource;
            if (!tempPackage.name.isEmpty() && !tempPackage.version.isEmpty() && !checker.isVersionBad(tempPackage.version) && !isBlacklisted(tempPackage))
                packageList.append(tempPackage);
        }
        inFile.close();
        removeOlds(packageList);
        return true;
    }
}

bool PackageDB::readBlacklist()
{
    blackList.clear();
    QFile inFile;

    inFile.setFileName(QDir::rootPath() + "/usr/share/mib-report/blacklist.txt");
    if (!inFile.open(QIODevice::ReadOnly | QIODevice::Text))
    {
        statusOK = false;
        statusString = "Error opening blacklist file " + QDir::rootPath() + "usr/share/mib-report/blacklist.txt";
        return false;
    }
    else
    {
        QTextStream fileIn(&inFile);
        while (!fileIn.atEnd())
        {
            Package tempPackage;
            QString line = fileIn.readLine();
            tempPackage.source = line.left(line.lastIndexOf(":")).simplified();
            tempPackage.name = line.right(line.length() - line.lastIndexOf(":") - 2).toLower().simplified();
            if (!tempPackage.name.isEmpty() && !tempPackage.source.isEmpty())
                blackList.append(tempPackage);
        }
        inFile.close();
        return true;
    }
}

bool PackageDB::isBlacklisted(Package inPackage)
{
    bool blacklisted = false;
    for (int j = 0; j < blackList.count(); j++)
    {
        if ((inPackage.name == blackList.at(j).name) && (inPackage.source == blackList.at(j).source))
        {
            blacklisted = true;
            break;
        }
    }
    return blacklisted;
}

bool PackageDB::readUrls()
{
    urlsList.clear();
    QFile inFile;

    inFile.setFileName(QDir::rootPath() + "/usr/share/mib-report/urls.txt");
    if (!inFile.open(QIODevice::ReadOnly | QIODevice::Text))
    {
        statusOK = false;
        statusString = "Error opening urls file " + QDir::rootPath() + "usr/share/mib-report/urls.txt";
        return false;
    }
    else
    {
        QTextStream fileIn(&inFile);
        while (!fileIn.atEnd())
        {
            Package tempPackage;
            QString line = fileIn.readLine();
            tempPackage.name = line.left(line.indexOf(":")).toLower().simplified();
            tempPackage.homepage = line.right(line.length() - line.indexOf(":") - 2).toLower().simplified();
            if (!tempPackage.name.isEmpty() && !tempPackage.homepage.isEmpty())
                urlsList.append(tempPackage);
        }
        inFile.close();
        return true;
    }
}

QString PackageDB::getPackageHomepage(QString packageName)
{
    QString homepage = "";
    for (int j = 0; j < urlsList.count(); j++)
    {
        if (packageName == urlsList.at(j).name)
        {
            homepage = urlsList.at(j).homepage;
            break;
        }
    }
    return homepage;
}


