#include <QtCore>
#include <package.h>
#include <versionchecker.h>
#include <globals.h>

#ifndef PACKAGEDB_H
#define PACKAGEDB_H

class PackageDB
{
public:
    PackageDB();
    bool statusOK;
    QString statusString;
    QList<Package> mib2009_1List;
    QList<Package> mib2010_0List;
    QList<Package> mib2010_2List;
    QList<Package> mib2011_0List;
    QList<Package> cookerList;
    QList<Package> restrictedList;
    QList<Package> eduList;
    QList<Package> mrbList;
    QList<Package> mageiaList;
    QList<Package> fedoraList;
    QList<Package> pclinuxosList;
    QList<Package> sisyphusList;
    QList<Package> opensuseList;
    QList<Package> gentooList;
    QList<Package> debianList;
    QList<Package> ubuntuList;
    QList<Package> mibPackagesList;
    QList<Package> newPackagesList;
    QList<Package> fullPackagesList;
    QList<Package> blackList;
    QList<Package> urlsList;
    int updateLists();
    void initDB();
    void generateHTMLTableMIB(int mode = REPORT_ALL);
    void generateHTMLTableMGAvsMDV(int mode = REPORT_ALL);
    void generateHTMLTableMDVvsMGA(int mode = REPORT_ALL);
    void search(QString packageName);
    void displayList(QList<Package> &packageList);

private:
    VersionChecker checker;
    QDir configPath;
    QString getPackageSource(QString packageName, QList<Package> &packageList);
    QString getPackageSourceUrl(QString packageName, QList<Package> &packageList);
    QString getPackageVersion(QString packageName, QList<Package> &packageList);
    QString getUpdatedSourceUrl(QString inFileName, Package inPackage);
    QString getPackageHomepage(QString packageName);
    void updateListSourceUrls(QString inFileName, QList<Package> &packageList);
    void removeOlds(QList<Package> &packageList);
    bool readPackages(QString inFileName, QList<Package> &packageList, QString packageSource);
    bool readBlacklist();
    bool isBlacklisted(Package inPackage);
    bool readUrls();
};

#endif // PACKAGEDB_H
