#include "versionchecker.h"

VersionChecker::VersionChecker()
{
}

bool VersionChecker::isVersionBad(QString version)
{
    // return false if there are 3 times more letters tnan numbers
    int numbers = 0;
    for (int j = 0; j < version.length(); j++)
    {
        if (version.at(j).isNumber())
            numbers++;
    }
    if (numbers < version.length() / 3)
        return true;
    else
        return false;
}

QString VersionChecker::normalizeVersion(QString version) const
{
    // separate numbers and letters with dots
    for (int j = 0; j < version.length(); j++)
    {
        if (!version.at(j).isDigit() && !version.at(j).isLetter())
            version.replace(j, 1, ".");
    }
    QString tempVersion = "";
    tempVersion = tempVersion + version.at(0);
    for (int j = 1; j < version.length(); j++)
    {
        if ((version.at(j-1).isDigit() && version.at(j).isLetter()) || (version.at(j-1).isLetter() && version.at(j).isDigit()))
            tempVersion = tempVersion + ".";
        tempVersion = tempVersion + version.at(j);
    }
    return tempVersion;
}

bool VersionChecker::firstVersionLess(QString version1, QString version2) const
{
    QString tempVersion1 = normalizeVersion(version1);
    QString tempVersion2 = normalizeVersion(version2);

    bool equal = true;
    while (equal)
    {
        int divider;
        QString subVersion1;
        QString subVersion2;

        divider = tempVersion1.indexOf(".");
        if (divider >= 0)
        {
            subVersion1 = tempVersion1.left(divider);
            tempVersion1 = tempVersion1.right(tempVersion1.length() - divider - 1);
        }
        else
        {
            subVersion1 = tempVersion1;
            tempVersion1 = "";
        }

        divider = tempVersion2.indexOf(".");
        if (divider >= 0)
        {
            subVersion2 = tempVersion2.left(divider);
            tempVersion2 = tempVersion2.right(tempVersion2.length() - divider - 1);
        }
        else
        {
            subVersion2 = tempVersion2;
            tempVersion2 = "";
        }
        if ((subVersion1 != subVersion2) || subVersion1.isEmpty())
        {
            tempVersion1 = subVersion1;
            tempVersion2 = subVersion2;
            equal = false;
        }
    }

    bool isNumber1;
    bool isNumber2;
    long number1 = tempVersion1.toLong(&isNumber1);
    long number2 = tempVersion2.toLong(&isNumber2);

    if (isNumber1 && isNumber2)
    {
        if (number1 < number2)
            return true;
        else
            return false;
    }
    else if (isNumber1 && !isNumber2)
        return false;
    else if (!isNumber1 && isNumber2)
        return true;
    else if (tempVersion1 < tempVersion2)
        return true;
    else
        return false;
}
